﻿using RyzStudio.Windows.ThemedForms;
using System;
using System.Windows.Forms;

namespace RandomFileRunner
{
    public class OptionsForm : TDialogForm
    {
        private TButton button1;
        private TYesNoPickerBox pickerBox1;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label label8;
        private RyzStudio.Windows.Forms.THorizontalSeparator tHorizontalSeparator1;
        private TNumericPickerBox pickerBox2;
        private TKeyCodeTextBox textBox1;
        private TYesNoPickerBox pickerBox3;
        private Label label1;
        private RyzStudio.Windows.Forms.THorizontalSeparator tHorizontalSeparator3;
        private Label label2;
        private RyzStudio.Windows.Forms.THorizontalSeparator tHorizontalSeparator2;


        public OptionsForm(AppSession session) : base()
        {
            InitializeComponent();

            this.Session = session;
        }

        private void InitializeComponent()
        {
            RyzStudio.Windows.ThemedForms.TKeyCodeTextBox.Results results1 = new RyzStudio.Windows.ThemedForms.TKeyCodeTextBox.Results();
            this.button1 = new RyzStudio.Windows.ThemedForms.TButton();
            this.pickerBox1 = new RyzStudio.Windows.ThemedForms.TYesNoPickerBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label8 = new System.Windows.Forms.Label();
            this.tHorizontalSeparator1 = new RyzStudio.Windows.Forms.THorizontalSeparator();
            this.tHorizontalSeparator2 = new RyzStudio.Windows.Forms.THorizontalSeparator();
            this.pickerBox2 = new RyzStudio.Windows.ThemedForms.TNumericPickerBox();
            this.textBox1 = new RyzStudio.Windows.ThemedForms.TKeyCodeTextBox();
            this.pickerBox3 = new RyzStudio.Windows.ThemedForms.TYesNoPickerBox();
            this.label1 = new System.Windows.Forms.Label();
            this.tHorizontalSeparator3 = new RyzStudio.Windows.Forms.THorizontalSeparator();
            this.label2 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.ActiveImage = null;
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.HoverImage = null;
            this.button1.IdleImage = null;
            this.button1.LabelText = "&Save";
            this.button1.Location = new System.Drawing.Point(241, 469);
            this.button1.Margin = new System.Windows.Forms.Padding(10, 0, 0, 10);
            this.button1.Name = "button1";
            this.button1.Padding = new System.Windows.Forms.Padding(4, 4, 3, 3);
            this.button1.Size = new System.Drawing.Size(128, 32);
            this.button1.TabIndex = 4;
            this.button1.MouseClick += new System.Windows.Forms.MouseEventHandler(this.button1_MouseClick);
            // 
            // pickerBox1
            // 
            this.pickerBox1.AcceptButton = null;
            this.pickerBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.pickerBox1.BackColor = System.Drawing.Color.Transparent;
            this.pickerBox1.Font = new System.Drawing.Font("Segoe UI", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point);
            this.pickerBox1.Location = new System.Drawing.Point(285, 21);
            this.pickerBox1.Margin = new System.Windows.Forms.Padding(10, 4, 10, 4);
            this.pickerBox1.Name = "pickerBox1";
            this.pickerBox1.Padding = new System.Windows.Forms.Padding(10, 6, 7, 5);
            this.pickerBox1.Size = new System.Drawing.Size(84, 35);
            this.pickerBox1.TabIndex = 0;
            this.pickerBox1.Value = true;
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.BackColor = System.Drawing.Color.Transparent;
            this.label6.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label6.Location = new System.Drawing.Point(10, 85);
            this.label6.Margin = new System.Windows.Forms.Padding(0);
            this.label6.Name = "label6";
            this.label6.Padding = new System.Windows.Forms.Padding(0, 9, 0, 10);
            this.label6.Size = new System.Drawing.Size(81, 34);
            this.label6.TabIndex = 182;
            this.label6.Text = "Retry On Error";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.BackColor = System.Drawing.Color.Transparent;
            this.label8.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label8.Location = new System.Drawing.Point(10, 21);
            this.label8.Margin = new System.Windows.Forms.Padding(0);
            this.label8.Name = "label8";
            this.label8.Padding = new System.Windows.Forms.Padding(0, 9, 0, 10);
            this.label8.Size = new System.Drawing.Size(143, 34);
            this.label8.TabIndex = 186;
            this.label8.Text = "Search Top Directory Only";
            this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // tHorizontalSeparator1
            // 
            this.tHorizontalSeparator1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.tHorizontalSeparator1.AutoScrollMargin = new System.Drawing.Size(0, 0);
            this.tHorizontalSeparator1.AutoScrollMinSize = new System.Drawing.Size(0, 0);
            this.tHorizontalSeparator1.BackColor = System.Drawing.Color.Transparent;
            this.tHorizontalSeparator1.Location = new System.Drawing.Point(10, 437);
            this.tHorizontalSeparator1.Margin = new System.Windows.Forms.Padding(5, 0, 5, 10);
            this.tHorizontalSeparator1.MaximumSize = new System.Drawing.Size(4920, 2);
            this.tHorizontalSeparator1.MinimumSize = new System.Drawing.Size(0, 22);
            this.tHorizontalSeparator1.Name = "tHorizontalSeparator1";
            this.tHorizontalSeparator1.Padding = new System.Windows.Forms.Padding(0, 10, 0, 10);
            this.tHorizontalSeparator1.Size = new System.Drawing.Size(364, 22);
            this.tHorizontalSeparator1.TabIndex = 188;
            this.tHorizontalSeparator1.TabStop = false;
            // 
            // tHorizontalSeparator2
            // 
            this.tHorizontalSeparator2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.tHorizontalSeparator2.AutoScrollMargin = new System.Drawing.Size(0, 0);
            this.tHorizontalSeparator2.AutoScrollMinSize = new System.Drawing.Size(0, 0);
            this.tHorizontalSeparator2.BackColor = System.Drawing.Color.Transparent;
            this.tHorizontalSeparator2.Location = new System.Drawing.Point(10, 59);
            this.tHorizontalSeparator2.Margin = new System.Windows.Forms.Padding(5, 0, 5, 10);
            this.tHorizontalSeparator2.MaximumSize = new System.Drawing.Size(4920, 2);
            this.tHorizontalSeparator2.MinimumSize = new System.Drawing.Size(0, 22);
            this.tHorizontalSeparator2.Name = "tHorizontalSeparator2";
            this.tHorizontalSeparator2.Padding = new System.Windows.Forms.Padding(0, 10, 0, 10);
            this.tHorizontalSeparator2.Size = new System.Drawing.Size(364, 22);
            this.tHorizontalSeparator2.TabIndex = 190;
            this.tHorizontalSeparator2.TabStop = false;
            // 
            // pickerBox2
            // 
            this.pickerBox2.AcceptButton = null;
            this.pickerBox2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.pickerBox2.BackColor = System.Drawing.Color.Transparent;
            this.pickerBox2.Font = new System.Drawing.Font("Segoe UI", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point);
            this.pickerBox2.Location = new System.Drawing.Point(285, 85);
            this.pickerBox2.Margin = new System.Windows.Forms.Padding(10, 4, 10, 4);
            this.pickerBox2.Name = "pickerBox2";
            this.pickerBox2.Padding = new System.Windows.Forms.Padding(10, 6, 7, 5);
            this.pickerBox2.Size = new System.Drawing.Size(84, 35);
            this.pickerBox2.TabIndex = 1;
            this.pickerBox2.Value = 0;
            // 
            // textBox1
            // 
            this.textBox1.AcceptButton = null;
            this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.textBox1.BackColor = System.Drawing.Color.Transparent;
            this.textBox1.Font = new System.Drawing.Font("Segoe UI", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point);
            this.textBox1.HighlightImage = null;
            results1.IsAlt = false;
            results1.IsCtrl = false;
            results1.IsShift = false;
            results1.Key = System.Windows.Forms.Keys.None;
            this.textBox1.KeyCodeResults = results1;
            this.textBox1.Location = new System.Drawing.Point(241, 197);
            this.textBox1.Margin = new System.Windows.Forms.Padding(10, 0, 0, 10);
            this.textBox1.Name = "textBox1";
            this.textBox1.NormalImage = null;
            this.textBox1.Padding = new System.Windows.Forms.Padding(10, 9, 9, 9);
            this.textBox1.Size = new System.Drawing.Size(128, 34);
            this.textBox1.TabIndex = 3;
            this.textBox1.UseSystemPasswordChar = false;
            // 
            // pickerBox3
            // 
            this.pickerBox3.AcceptButton = null;
            this.pickerBox3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.pickerBox3.BackColor = System.Drawing.Color.Transparent;
            this.pickerBox3.Font = new System.Drawing.Font("Segoe UI", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point);
            this.pickerBox3.Location = new System.Drawing.Point(285, 127);
            this.pickerBox3.Margin = new System.Windows.Forms.Padding(10, 4, 10, 4);
            this.pickerBox3.Name = "pickerBox3";
            this.pickerBox3.Padding = new System.Windows.Forms.Padding(10, 6, 7, 5);
            this.pickerBox3.Size = new System.Drawing.Size(84, 35);
            this.pickerBox3.TabIndex = 2;
            this.pickerBox3.Value = true;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.BackColor = System.Drawing.Color.Transparent;
            this.label1.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label1.Location = new System.Drawing.Point(10, 127);
            this.label1.Margin = new System.Windows.Forms.Padding(0);
            this.label1.Name = "label1";
            this.label1.Padding = new System.Windows.Forms.Padding(0, 9, 0, 10);
            this.label1.Size = new System.Drawing.Size(169, 34);
            this.label1.TabIndex = 196;
            this.label1.Text = "Close Current Process On Next";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // tHorizontalSeparator3
            // 
            this.tHorizontalSeparator3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.tHorizontalSeparator3.AutoScrollMargin = new System.Drawing.Size(0, 0);
            this.tHorizontalSeparator3.AutoScrollMinSize = new System.Drawing.Size(0, 0);
            this.tHorizontalSeparator3.BackColor = System.Drawing.Color.Transparent;
            this.tHorizontalSeparator3.Location = new System.Drawing.Point(10, 165);
            this.tHorizontalSeparator3.Margin = new System.Windows.Forms.Padding(5, 0, 5, 10);
            this.tHorizontalSeparator3.MaximumSize = new System.Drawing.Size(4920, 2);
            this.tHorizontalSeparator3.MinimumSize = new System.Drawing.Size(0, 22);
            this.tHorizontalSeparator3.Name = "tHorizontalSeparator3";
            this.tHorizontalSeparator3.Padding = new System.Windows.Forms.Padding(0, 10, 0, 10);
            this.tHorizontalSeparator3.Size = new System.Drawing.Size(364, 22);
            this.tHorizontalSeparator3.TabIndex = 197;
            this.tHorizontalSeparator3.TabStop = false;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.BackColor = System.Drawing.Color.Transparent;
            this.label2.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label2.Location = new System.Drawing.Point(10, 197);
            this.label2.Margin = new System.Windows.Forms.Padding(0);
            this.label2.Name = "label2";
            this.label2.Padding = new System.Windows.Forms.Padding(0, 9, 0, 10);
            this.label2.Size = new System.Drawing.Size(123, 34);
            this.label2.TabIndex = 198;
            this.label2.Text = "Next File Shortcut Key";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // OptionsForm
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(7F, 15F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(384, 521);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.tHorizontalSeparator3);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.pickerBox3);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.pickerBox2);
            this.Controls.Add(this.tHorizontalSeparator2);
            this.Controls.Add(this.tHorizontalSeparator1);
            this.Controls.Add(this.label8);
            this.Controls.Add(this.pickerBox1);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.button1);
            this.MinimumSize = new System.Drawing.Size(400, 560);
            this.Name = "OptionsForm";
            this.Text = "Options";
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);

            this.DialogResult = System.Windows.Forms.DialogResult.None;

            pickerBox1.Value = this.Session.SearchTopDirectoryOnly;
            pickerBox2.Clear(0, 20, this.Session.RetryOnError);
            pickerBox3.Value = this.Session.ClosePrevOnNext;
            if (this.Session.NextHotKey != null) textBox1.UpdateKeyCode(this.Session.NextHotKey.IsCtrl, this.Session.NextHotKey.IsAlt, this.Session.NextHotKey.IsShift, this.Session.NextHotKey.KeyCode);
        }


        public AppSession Session { get; protected set; }


        private void button1_MouseClick(object sender, MouseEventArgs e)
        {
            if (this.Session == null) this.Session = new AppSession();

            this.Session.SearchTopDirectoryOnly = pickerBox1.Value;
            this.Session.RetryOnError = pickerBox2.Value;
            this.Session.ClosePrevOnNext = pickerBox3.Value;
            this.Session.NextHotKey.IsCtrl = textBox1.KeyCodeResults.IsCtrl;
            this.Session.NextHotKey.IsAlt = textBox1.KeyCodeResults.IsAlt;
            this.Session.NextHotKey.IsShift = textBox1.KeyCodeResults.IsShift;
            this.Session.NextHotKey.Key = textBox1.KeyCodeResults.KeyCode;

            this.DialogResult = DialogResult.OK;
            this.Close();
        }

    }
}